#include "native.h"

void __stdcall NtProcessStartup(PPEB Argument)
{
	NTSTATUS code;

	char str[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz\nŨ";

	zenwinx_native_init();
	winx_init(Argument);

	winx_printf("%s\n\n", str);
	winx_getch();

	code = InitRussian();
	if(code != STATUS_SUCCESS)
	{
		winx_printf("Error: 0x%x - %d\n", code, RtlNtStatusToDosError(code));
	}

	winx_printf("%s\n\n", str);
	winx_getch();

	winx_exit(0);
	return;
}

NTSTATUS InitRussian()
{
	PRTL_PROCESS_MODULE_INFORMATION minfo = NULL;
	NTSTATUS code;
	ULONG i, m_size, glyph_offset = 0, image_size = 0;
	PVOID image = NULL;

	/* ,   RTL_PROCESS_MODULE_INFORMATION */
	code = NtQuerySystemInformation(SystemModuleInformation, minfo, 0, &m_size);
	if(code != STATUS_INFO_LENGTH_MISMATCH)
	{
		return code;
	}

	/*   */
	code = AllocMemory((PVOID *)&minfo, m_size);
	if(!NT_SUCCESS(code))
	{
		return code;
	}

	/*   */
	code = NtQuerySystemInformation(SystemModuleInformation, minfo, m_size, NULL);
	if(!NT_SUCCESS(code))
	{
		FreeMemory(minfo, m_size);
		return code;
	}

	/*     */
	m_size = *(PULONG)minfo;
	minfo = (PRTL_PROCESS_MODULE_INFORMATION)((PUCHAR)minfo + 4);
	
	/*   */
	for(i = 0; i < m_size; i++)
	{
		if(strstr(minfo[i].FullPathName, "BOOTVID"))
		{
			image_size = minfo[i].ImageSize;

			/*     bootvid */
			code = AllocMemory(&image, image_size);
			if(!NT_SUCCESS(code))
			{
				FreeMemory(minfo, m_size);
				return code;
			}

			/*    bootvid   */
			code = ReadVirtualMemory(minfo[i].ImageBase, image, image_size);
			if(!NT_SUCCESS(code))
			{
				FreeMemory(minfo, m_size);
				FreeMemory(image, image_size);
				return code;
			}
			/*     */
			glyph_offset = search((char *)image, first_glyph, image_size, GLYPH_SIZE);
			
			if(glyph_offset != 0)
			{
				/*   128   */
				glyph_offset += (128 * GLYPH_SIZE) + (ULONG)minfo[i].ImageBase;
				/*      */
				return WriteVirtualMemory((PVOID)glyph_offset, ru_glyph, sizeof(ru_glyph));
			}
		}
	}

	/*   */
	FreeMemory(minfo, m_size);
	FreeMemory(image, image_size);

	return STATUS_NOT_FOUND;
}

NTSTATUS AllocMemory(PVOID * addr, ULONG size)
{
     return NtAllocateVirtualMemory(NtCurrentProcess(), addr, 0, &size, MEM_COMMIT, PAGE_READWRITE);
}

NTSTATUS FreeMemory(PVOID addr, ULONG size)
{
	return NtFreeVirtualMemory(NtCurrentProcess(), &addr, &size, MEM_RELEASE);
}

NTSTATUS ReadVirtualMemory(PVOID VirtualAddress, PVOID Buffer, ULONG BufferSize)
{

	SYSDBG_VIRTUAL MemoryChunks;
	MemoryChunks.Address = VirtualAddress;
	MemoryChunks.Buffer = Buffer;
	MemoryChunks.Request = BufferSize;
	return NtSystemDebugControl(SysDbgReadVirtual, &MemoryChunks, sizeof(MemoryChunks), NULL, 0, NULL);
}

NTSTATUS WriteVirtualMemory(PVOID VirtualAddress, PVOID Buffer, ULONG BufferSize)
{
	SYSDBG_VIRTUAL MemoryChunks;
	MemoryChunks.Address = VirtualAddress;
	MemoryChunks.Buffer = Buffer;
	MemoryChunks.Request = BufferSize;
	return NtSystemDebugControl(SysDbgWriteVirtual, &MemoryChunks, sizeof(MemoryChunks), NULL, 0, NULL);
}

ULONG __stdcall search(char *x, char *y, unsigned int n, unsigned int m)
{
	unsigned int i;
	char first, second, *third;
	first = y[0]; 
	second = y[1]; 
	third = &y[2];

	for(i = 0; i < n; i++)
	{
		if(x[i] == first && x[i+1] == second)
		{
			if(RtlCompareMemory(&x[i+2], third, m - 2) == m - 2)
			{
				return i;
			}
		}
	}

	return 0;
}
